#include <windows.h>
#include	"mmsystem.h"		// }`fBAVXe

//
//	Constants
//
#define	BUFNUM		4
#define	BUFSIZE		4096
#define	QUEUENUM	8

//
//	Global vars
//
HANDLE		hHeap;
WAVEHDR		OutHdr[BUFNUM];
CHAR			OutBuffer[BUFNUM][BUFSIZE];
WAVEHDR		InHdr[BUFNUM];
CHAR			InBuffer[BUFNUM][BUFSIZE];
CHAR			SoundBuf[BUFSIZE];

CHAR			RecQueue[QUEUENUM][BUFSIZE];
CHAR			PlayQueue[QUEUENUM][BUFSIZE];

DWORD			RecQueueIn, RecQueueOut;
DWORD			PlayQueueIn, PlayQueueOut;

HMMIO			hFileHandle;
DWORD			DataSize;
WAVEFORMATEX	WaveFormat;
MMIOINFO	ioInfo;
MMCKINFO	RiffChunk;
MMCKINFO	SubChunk;
LPWSTR		FileName;

HWAVEOUT	hOutHandle;
DWORD			OutBufPage;
DWORD			CurPos;

HWAVEIN		hInHandle;
long			InBufPage;
DWORD			InDataSize;			

bool			RepeatFlag;
bool			OutOnly;

BOOL WINAPI DllMain(HINSTANCE hDLL, DWORD dwReason, LPVOID lpReserved)
{
	return TRUE;
}

//
//	CHeck record queue number
//
long __stdcall CheckQueue()
{
int i;
	if(OutOnly)	// Imput device is unavailable?
	{	// Sync by output device
		i = PlayQueueIn - PlayQueueOut;
		if(i < 0)
			i += QUEUENUM;	// Make it plus
		i = (i < QUEUENUM / 2);	// Que have space?
	}
	else	// Sync by input device
	{
		i = RecQueueIn - RecQueueOut;
		if(i < 0)
			i += QUEUENUM;
	}
	return (long)i;
}

//
//	Get recording queue
//
void __stdcall GetRecData(LPSTR buf)
{
	if(!CheckQueue())	// No data queued
	{
		if(buf)	// buffer specified?
			memset(buf, 0, BUFSIZE);
	}
	else
	{
		if(buf)	// buffer specified?
			memcpy(buf, RecQueue[RecQueueOut], BUFSIZE);
		if(RecQueueOut == QUEUENUM - 1)
			RecQueueOut = 0;
		else
			RecQueueOut++;
	}
}

//
//	put playback queue
//
void __stdcall PutPlayData(LPSTR buf)
{
int	i;
	i = PlayQueueIn - PlayQueueOut;
	if(i < 0)
		i += QUEUENUM;	// Make it plus
	if(i < QUEUENUM - 1)	// Have space?
	{
		memcpy(PlayQueue[PlayQueueIn], buf, BUFSIZE);
		if(PlayQueueIn == QUEUENUM - 1)
			PlayQueueIn = 0;
		else
			PlayQueueIn++;
	}
}

//
// Get data from queue
//
BOOL GetSoundData(HWAVEOUT hWavePlay, LPWAVEHDR	pWaveHdr)
{
int	i;
MMRESULT ret = MMSYSERR_NOERROR;

	if (OutBufPage == 0)
	{
		return FALSE;			// łɏꂽobt@݂͑Ȃ
	}
	if (!(pWaveHdr->dwFlags & WHDR_DONE))
	{
		return FALSE;			// ܂tł
	}
	if (!(pWaveHdr->dwFlags & WHDR_PREPARED))
	{
		return FALSE;			// ꂽobt@ł͂Ȃ
	}
	ret = waveOutUnprepareHeader(hWavePlay, pWaveHdr, sizeof(WAVEHDR));

	if (ret != MMSYSERR_NOERROR)
	{
//			printf("WAVE out unprepare headder\n");
	}
	if (ret == MMSYSERR_NOERROR)
	{
		OutBufPage--;
	}
	i = PlayQueueIn - PlayQueueOut;
	if(i < 0)
		i += QUEUENUM;	// Make it plus
	if(i)	// Queued data exists?
	{
		memcpy(pWaveHdr->lpData, PlayQueue[PlayQueueOut], BUFSIZE);
		if(PlayQueueOut == QUEUENUM - 1)
			PlayQueueOut = 0;
		else
			PlayQueueOut++;
	}
	else	// No data is queued
	{
		memset(pWaveHdr->lpData, 0, BUFSIZE);	// Clear
	}
	pWaveHdr->dwBufferLength = BUFSIZE;
	pWaveHdr->dwFlags = 0;

	ret = waveOutPrepareHeader(hWavePlay, pWaveHdr, sizeof(WAVEHDR));

	if (ret != MMSYSERR_NOERROR)
	{
//			printf("WAVE out unprepare headder\n");
	}
	ret = waveOutWrite(hWavePlay, pWaveHdr, sizeof(WAVEHDR));

	if (ret != MMSYSERR_NOERROR)
	{
//			printf("WAVE out write error\n");
	}
	OutBufPage++;

	return (ret == MMSYSERR_NOERROR) ? TRUE : FALSE;
}


//
//	Wave device message handler
//
void CALLBACK WaveOutHandler(HWAVEOUT hwo, UINT uMsg, DWORD_PTR dwInstance, DWORD dwParam1, DWORD dwParam2)
{
	switch (uMsg)
	{
	case MM_WOM_OPEN:
		break;
	case MM_WOM_CLOSE:
		break;
	case MM_WOM_DONE:
		GetSoundData(hwo, (LPWAVEHDR)dwParam1);
		break;
	}
}

//
// Put recorded wave data to queue
//
BOOL SetSoundData(HWAVEIN hWaveRec, LPWAVEHDR pWaveHdr)
{
MMRESULT ret = MMSYSERR_NOERROR;
int	i;
	if (InBufPage == 0)
	{
		return FALSE;			// łɏꂽobt@݂͑Ȃ
	}
	if (!(pWaveHdr->dwFlags & WHDR_DONE))
	{
		return FALSE;			// ܂^ł
	}
	if (!(pWaveHdr->dwFlags & WHDR_PREPARED))
	{
		return FALSE;			// ꂽobt@ł͂Ȃ
	}
	i = RecQueueIn - RecQueueOut;	// Get queued count
	if(i < 0)
		i += QUEUENUM;	// Make it plus
	if(i < QUEUENUM - 1)	// Have space to put queue?
	{
		memcpy(RecQueue[RecQueueIn], pWaveHdr->lpData, BUFSIZE);
		if(RecQueueIn == QUEUENUM - 1)
			RecQueueIn = 0;
		else
			RecQueueIn++;
	}

	ret = waveInUnprepareHeader(hInHandle, pWaveHdr, sizeof(WAVEHDR));

	if (ret != MMSYSERR_NOERROR)
	{
//		printf("Can't unprepare");
	}
	if (ret == MMSYSERR_NOERROR)
	{
		InBufPage--;
	}

	pWaveHdr->dwFlags = 0;

	ret = waveInPrepareHeader(hInHandle, pWaveHdr, sizeof(WAVEHDR));

	if (ret != MMSYSERR_NOERROR)
	{
//		printf("Can't unprepare");
	}
	ret = waveInAddBuffer(hInHandle, pWaveHdr, sizeof(WAVEHDR));

	if (ret != MMSYSERR_NOERROR)
	{
//		printf("Can't add");
	}
	InBufPage++;
	return (ret == MMSYSERR_NOERROR) ? TRUE : FALSE;
}

//
//	Wave device message handler
//
void CALLBACK WaveInHandler(HWAVEIN hwo, UINT uMsg, DWORD_PTR dwInstance, DWORD dwParam1, DWORD dwParam2)
{
	switch (uMsg)
	{
	case MM_WIM_OPEN:
		break;
	case MM_WIM_CLOSE:
		break;
	case MM_WIM_DATA:
		SetSoundData(hwo, (LPWAVEHDR)dwParam1);
		break;
	}
}

//
//
//
int __stdcall SetupOutBuffer()
{
int	i, j;
// Check WAVE_MAPPER supports specified WAVE format
	if(waveOutOpen(NULL, WAVE_MAPPER, &WaveFormat, 0, 0, WAVE_FORMAT_QUERY) != MMSYSERR_NOERROR)
		return 1;
	waveOutOpen(&hOutHandle, WAVE_MAPPER, &WaveFormat, (DWORD_PTR)WaveOutHandler, 0, CALLBACK_FUNCTION);

	OutBufPage = 0;
	for(i = 0; i < BUFNUM; i++)
	{
	LPWAVEHDR WaveHdr= &OutHdr[i];
		WaveHdr->lpData = &OutBuffer[i][0];
		WaveHdr->dwUser = 0;
		WaveHdr->dwFlags = 0;
		WaveHdr->dwLoops = 0;

		memset(WaveHdr->lpData, 0, BUFSIZE);	// Clear
		WaveHdr->dwBufferLength = BUFSIZE;

		j = waveOutPrepareHeader(hOutHandle, WaveHdr, sizeof(WAVEHDR));

		if (j != MMSYSERR_NOERROR)
		{
//			fprintf(stderr, "Can't write audio headder\n");
			break;
		}
		j = waveOutWrite(hOutHandle, WaveHdr, sizeof(WAVEHDR));

		if (j != MMSYSERR_NOERROR)
		{
//			fprintf(stderr, "Can't write audio data\n");
			break;
		}
		OutBufPage++;
	}
	return 0;
}

void __stdcall StartCapture(void)
{
	waveInStart(hInHandle);
}

//
//
//
int __stdcall SetupInBuffer()
{
int	i, j;
	OutOnly = true;
	if(waveInOpen(NULL, WAVE_MAPPER, &WaveFormat, 0, 0, WAVE_FORMAT_QUERY) != MMSYSERR_NOERROR)
		return 1;
	OutOnly = false;
	waveInOpen(&hInHandle, WAVE_MAPPER, &WaveFormat, (DWORD_PTR)WaveInHandler, 0, CALLBACK_FUNCTION);

	InBufPage = 0;
	for(i = 0; i < BUFNUM; i++)
	{
	LPWAVEHDR WaveHdr = &InHdr[i];
		WaveHdr->lpData = InBuffer[i];
		WaveHdr->dwBufferLength = BUFSIZE;
		WaveHdr->dwUser = 0;
		WaveHdr->dwFlags = 0;
		WaveHdr->dwLoops = 0;

		j = waveInPrepareHeader(hInHandle, WaveHdr, sizeof(WAVEHDR));

		if (j != MMSYSERR_NOERROR)
		{
//			printf("Can't prepare headder");
			break;
		}
		j = waveInAddBuffer(hInHandle, WaveHdr, sizeof(WAVEHDR));

		if (j != MMSYSERR_NOERROR)
		{
//			printf("Can't add headder");
			break;
		}
		InBufPage++;
	}
	return 0;
}
//
//	Wave setup
//
void __stdcall WaveFormatSetup(long sample)
{
	ZeroMemory(&WaveFormat, sizeof(WaveFormat));	// Clear memory
	WaveFormat.wFormatTag      = WAVE_FORMAT_PCM;
	WaveFormat.nChannels       = 2;
	WaveFormat.nSamplesPerSec  = (DWORD)sample;
	WaveFormat.nAvgBytesPerSec = 2 * 2 * sample;
	WaveFormat.nBlockAlign     = 2 * 2;
	WaveFormat.wBitsPerSample  = 16;
	WaveFormat.cbSize	= 0;
}


//
//	Heap init
//
void __stdcall HeapInit(void)
{
int i;
	for(i = 0; i < BUFNUM; i++)
	{
		ZeroMemory(&OutHdr[i], sizeof(WAVEHDR));
		ZeroMemory(&InHdr[i], sizeof(WAVEHDR));
	}

	RecQueueIn = 0;
	RecQueueOut = 0;
	PlayQueueIn = 0;
	PlayQueueOut = 0;

}

//
// Stop Play Wave
//
void StopAudioDevice(void)
{
int i;
	if(hOutHandle)
	{
		waveOutPause(hOutHandle);
//		waveOutReset(hOutHandle);
		for(i = 0; i < BUFNUM; i++)
		{
			if(!(OutHdr[i].dwFlags & WHDR_PREPARED))
				continue;
			if(!(OutHdr[i].dwFlags & WHDR_DONE))
				continue;
			waveOutUnprepareHeader(hOutHandle, &OutHdr[i], sizeof(WAVEHDR));
		}
	}
	if(hInHandle)
	{
		waveInStop(hInHandle);
//		waveInReset(hInHandle);
		for(i = 0; i < BUFNUM; i++)
		{
			if(!(InHdr[i].dwFlags & WHDR_PREPARED))
				continue;
			if(!(InHdr[i].dwFlags & WHDR_DONE))
				continue;
			waveInUnprepareHeader(hInHandle, &InHdr[i], sizeof(WAVEHDR));
		}
	}
//	Sleep(100);
}

//
//	Cleanup heap
//
void __stdcall HeapCleanUp(void)
{
	StopAudioDevice();
	waveInClose(hInHandle);
	waveOutClose(hOutHandle);
}
